/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.sign.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.springblade.modules.sign.dto.SignDTO;
import org.springblade.modules.sign.entity.SignEntity;
import org.springblade.modules.sign.excel.SignExcel;
import org.springblade.modules.sign.excel.SignExceptionExcel;
import org.springblade.modules.sign.vo.BmVO;
import org.springblade.modules.sign.vo.SignExceptionVO;
import org.springblade.modules.sign.vo.SignVO;
import org.springblade.modules.sign.vo.SignVOS;
import org.springblade.modules.system.entity.User;

import java.util.List;
import java.util.Map;

/**
 * 考勤 Mapper 接口
 *
 * @author BladeX
 * @since 2023-07-07
 */
public interface SignMapper extends BaseMapper<SignEntity> {

	/**
	 * 自定义分页
	 *
	 * @param page
	 * @return
	 */
	List<SignVO> selectSignPage(IPage page, SignVO signVOa);


	/**
	 * 获取导出数据
	 *
	 * @param queryWrapper
	 * @return
	 */
	List<SignExcel> exportSign(@Param("ew") Wrapper<SignEntity> queryWrapper);

	List<SignEntity>  selectDkjlByUserid(Long userId);

	int getKgCs(@Param("params") Map<String, Object> params);

	List<SignEntity>  selectDkjlByUserid(Long userId,String yf);

	List<SignDTO> getSignUser();

	void autoAbsent(SignEntity signEntity);

	List<SignVOS> selectSign(Long userId,String Mathvalue);

	List<BmVO> selectBm(String deptId);

	List<SignVO> selectSignUser(IPage page, SignVO signVOa);


	List<User> getUserListByRoleId();

	List<SignExceptionVO> getSignException(IPage<SignExceptionVO> page, @Param("params") Map<String, Object> params);

	List<SignExceptionExcel> exportInfo(@Param("params") Map<String, Object> params);

	SignEntity getSignZpById(@Param("params") Map<String, Object> params);
    String getRqType();
}
